package com.javainuse.domain.service;

import java.math.BigDecimal;

import com.javainuse.domain.model.Account;
import com.javainuse.domain.port.incoming.Deposit;
import com.javainuse.domain.port.incoming.Withdraw;
import com.javainuse.domain.port.outgoing.PersistAccount;
import com.javainuse.domain.port.outgoing.RetrieveAccount;

public class AccountService implements Deposit, Withdraw {

    private RetrieveAccount retrieveAccount;
    private PersistAccount persistAccount;

    public AccountService(RetrieveAccount retrieveAccount, PersistAccount persistAccount) {
        this.retrieveAccount = retrieveAccount;
        this.persistAccount = persistAccount;
    }

    public void deposit(Long accountNo, BigDecimal depositAmount) {
        Account account = retrieveAccount.load(accountNo);
        account.depositAmount(depositAmount);
        persistAccount.save(account);
    }

    public boolean withdraw(Long accountNo, BigDecimal withdrawalAmount) {
        Account account = retrieveAccount.load(accountNo);
        boolean withdrawSucess = account.withdrawAmount(withdrawalAmount);

        if (withdrawSucess) {
            persistAccount.save(account);
        }
        return withdrawSucess;
    }
}