package com.javainuse.infrastructure.adapter;

import org.springframework.stereotype.Component;

import com.javainuse.domain.model.Account;
import com.javainuse.domain.port.outgoing.PersistAccount;
import com.javainuse.domain.port.outgoing.RetrieveAccount;

@Component
public class AccountRepository implements RetrieveAccount, PersistAccount {

    private SpringDataAccountRepository repository;

    public AccountRepository(SpringDataAccountRepository repository) {
        this.repository = repository;
    }

    public Account load(Long accountNo) {
        return repository.findByAccountNo(accountNo);
    }

    public void save(Account bankAccount) {
        repository.save(bankAccount);
    }
}
